package demos.nonswing;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.LayoutManager;
import java.awt.font.FontRenderContext;
import java.awt.geom.Rectangle2D;
import java.text.SimpleDateFormat;
import java.util.*;
import javax.swing.JFrame;
import javax.swing.JPanel;

public class ClockDemo {
    public static void main(String[] args) {
        new ClockDemo();
    }
    public ClockDemo() {
        window = new JFrame();
        window.setTitle("Clocks!");
        window.setResizable(true);
        window.setDefaultCloseOperation(3);
        window.setLayout(new FlowLayout());
        clock = new GUIClock(Color.black,Color.green,12,false);
        window.add(clock);
        secondClock = new GUIClock(Color.white,Color.black,36,true);
        window.add(secondClock);
        thirdClock = new GUIClock(Color.darkGray,Color.red,72,false);
        window.add(thirdClock);
        if (SPECIAL$window$hasLayout)
            for (Component comp : SPECIAL$window$layoutChildren)
                window.add(comp);
        window.setVisible(true);
        window.pack();
    }
    public JFrame window;
    private boolean SPECIAL$window$hasLayout = false;
    public GUIClock thirdClock;
    public GUIClock secondClock;
    public GUIClock clock;
    private final List<Component> SPECIAL$window$layoutChildren =
        new ArrayList<Component>();
    public String getWindowTitle(JFrame window) {
        return window.getTitle();
    }
    public void setWindowTitle(JFrame window, String newTitle) {
        window.setTitle(newTitle);
    }
    public LayoutManager getWindowLayout(JFrame window) {
        return window.getLayout();
    }
    public void setWindowLayout(JFrame window, LayoutManager newLayout) {
        window.setLayout(newLayout);
    }
    public boolean getWindowResizable(JFrame window) {
        return window.isResizable();
    }
    public void setWindowResizable(JFrame window, boolean newResizable) {
        window.setResizable(newResizable);
    }
    public int getWindowWidth(JFrame window) {
        return window.getWidth();
    }
    public void setWindowWidth(JFrame window, int newWidth) {
        Dimension newDimension = new Dimension(newWidth,window.getHeight());
        window.setPreferredSize(newDimension);
    }
    public int getWindowHeight(JFrame window) {
        return window.getHeight();
    }
    public void setWindowHeight(JFrame window, int newHeight) {
        Dimension newDimension = new Dimension(window.getWidth(),newHeight);
        window.setPreferredSize(newDimension);
    }
    public Color getWindowBackgroundColor(JFrame window) {
        return window.getBackground();
    }
    public void setWindowBackgroundColor(JFrame window, Color newBackgroundColor) {
        window.setBackground(newBackgroundColor);
    }
    public int getWindowOnClose(JFrame window) {
        return window.getDefaultCloseOperation();
    }
    public void setWindowOnClose(JFrame window, int newClose) {
        window.setDefaultCloseOperation(newClose);
    }
    public class GUIClock extends JPanel {
    	String time;
    	String format;
    	Timer timer;
    	Font clockFont;
    	Color backgroundColor;
    	Color textColor;
    	long refreshRate = 1000;
    	public GUIClock(Color bC, Color tC, int size, boolean seconds){
    		if (seconds) { format="hh:mm:ss"; time = "00:00:00"; }
    		else { format = "hh:mm";  time = "00:00"; }
    		backgroundColor = bC;
    		textColor = tC;
    		clockFont = new Font("Footlight MT Light", Font.BOLD, size);
    		timer = new Timer();
    		timer.scheduleAtFixedRate(new ClockTick(this),0,refreshRate);
    		Rectangle2D bounds = clockFont.getStringBounds(time,new FontRenderContext(null,true,true));
    		setPreferredSize(new Dimension((int)bounds.getWidth()+10,(int)bounds.getHeight()+10));
    	}
    	public void setRefreshRate(long refreshRate){
    		timer.cancel();		timer = new Timer();
    		timer.scheduleAtFixedRate(new ClockTick(this),0,refreshRate);
    	}	public void killClock(){
    		timer.cancel();
    	}
    	protected void paintComponent(Graphics g){
    		g.setFont(clockFont);
    		FontMetrics metrics = g.getFontMetrics();
    		Rectangle2D bounds = g.getFontMetrics().getStringBounds(time,g);
    		g.setColor(backgroundColor);
    		g.fillRect(-5,-5,(int)bounds.getWidth()+20,(int)bounds.getHeight()+20);
    		g.setColor(textColor);
    		g.drawString(time,5,(metrics.getHeight()+ metrics.getAscent()+8)/2);
    	}
    	public class ClockTick extends TimerTask{
    		GUIClock clock;
    		public ClockTick(GUIClock clock){
    			this.clock = clock;
    		}
    		public void run() {
    			Date date = new Date();
    			SimpleDateFormat formatter = new SimpleDateFormat(clock.format);
    			clock.time = formatter.format(date);
    			clock.repaint();
    		}
    	}
    }
}
