package elvisDoc;
import java.io.Serializable;
import java.util.Hashtable;


public class elvisDocItem implements Serializable {
	
	// default serialVersionUID; can change if needed.
	private static final long serialVersionUID = 1L;
	
	public elvisDocItem parent;
	public String name;
	public String parentName;
	public String description;
	static String linkCaller = "@ELink";
	
	public Hashtable<String, elvisDocAttribute> attrs;	
	public Hashtable<String, elvisDocItem> children;
	

	public elvisDocItem()
	{
		parentName = "";
		attrs = new Hashtable<String, elvisDocAttribute>();
		children = new Hashtable<String, elvisDocItem>();
		
	}
	
	public String getDescription(boolean omitLinks) {
		
		if(omitLinks) {
			return omitLinks(description);
		}
		else {
			return description;
		}
	}
	
	public void setDescription(String newDescription) {
		description = newDescription;
	}
	
	private String omitLinks(String in) {
		while(in.contains(linkCaller)) {
			in = in.substring(0, in.indexOf(linkCaller)) + in.substring(in.indexOf(linkCaller) + linkCaller.length());
		}
		return in;
	}
	
	public void addAttribute(String name, String description, String defaultValue) {
		
		//System.out.println("Adding " + name + ". " + description + "(" + defaultValue + ")");
		//System.out.println(attrs.containsKey(name));
		if(attrs.containsKey(name)) {
			//System.out.println(description.equals(""));
			elvisDocAttribute eda = attrs.get(name);
			if(!defaultValue.equals("")) eda.defaultValue = defaultValue;
			if(!description.equals("")) eda.setDescription(description);
			if(!name.equals("")) eda.name = name;
		}
		else {
			attrs.put(name, new elvisDocAttribute(name, description, defaultValue));
		}
		
	}
	
}