package learningTool;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.GridLayout;
import java.awt.LayoutManager;
import java.awt.Point;
import java.awt.event.*;
import java.io.File;
import java.util.*;
import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSeparator;
import javax.swing.JTextArea;
import javax.swing.JTree;
import javax.swing.OverlayLayout;
import javax.swing.SwingUtilities;
import javax.swing.event.*;
import javax.swing.filechooser.*;
import javax.swing.tree.DefaultMutableTreeNode;

public class LearningToolGUI {
    public final Controller controller;
    public LearningToolGUI(Controller c) {
        controller = c;
        
        // Construct Window window
        window = new JFrame();
        window.setTitle("Learn Java with Elvis");
        window.setResizable(true);
        window.setDefaultCloseOperation(3);
        
        // Construct MenuBar (anonymous)
        anon$MenuBar$0 = new JMenuBar();
        
        // Construct Menu fileMenu
        fileMenu = new JMenu();
        fileMenu.setText("File");
        fileMenu.setMnemonic(KeyEvent.VK_F);
        
        // Construct MenuItem newItem
        newItem = new JMenuItem();
        {
            class temp$newItem$OnClickHandler implements ActionListener {
                public void actionPerformed(ActionEvent event) {
                    if (controller != null) controller.newDoc(newItem, event);
                }
            }
            newItem.addActionListener(new temp$newItem$OnClickHandler());
        }
        newItem.setText("New...");
        newItem.setMnemonic(KeyEvent.VK_N);
        newItem.setEnabled(true);
        fileMenu.add(newItem);
        
        // Construct MenuItem openItem
        openItem = new JMenuItem();
        {
            class temp$openItem$OnClickHandler implements ActionListener {
                public void actionPerformed(ActionEvent event) {
                    if (controller != null) controller.open(openItem, event);
                }
            }
            openItem.addActionListener(new temp$openItem$OnClickHandler());
        }
        openItem.setText("Open...");
        openItem.setMnemonic(KeyEvent.VK_O);
        openItem.setEnabled(true);
        fileMenu.add(openItem);
        
        // Construct MenuSeparator (anonymous)
        anon$MenuSeparator$1 = new JSeparator();
        fileMenu.add(anon$MenuSeparator$1);
        
        // Construct MenuItem saveItem
        saveItem = new JMenuItem();
        {
            class temp$saveItem$OnClickHandler implements ActionListener {
                public void actionPerformed(ActionEvent event) {
                    if (controller != null) controller.save(saveItem, event);
                }
            }
            saveItem.addActionListener(new temp$saveItem$OnClickHandler());
        }
        saveItem.setText("Save");
        saveItem.setMnemonic(KeyEvent.VK_S);
        saveItem.setEnabled(true);
        fileMenu.add(saveItem);
        
        // Construct MenuItem saveAsItem
        saveAsItem = new JMenuItem();
        {
            class temp$saveAsItem$OnClickHandler implements ActionListener {
                public void actionPerformed(ActionEvent event) {
                    if (controller != null) controller.saveAs(saveAsItem, event);
                }
            }
            saveAsItem.addActionListener(new temp$saveAsItem$OnClickHandler());
        }
        saveAsItem.setText("Save As...");
        saveAsItem.setMnemonic(KeyEvent.VK_A);
        saveAsItem.setEnabled(true);
        fileMenu.add(saveAsItem);
        
        // Construct MenuSeparator (anonymous)
        anon$MenuSeparator$2 = new JSeparator();
        fileMenu.add(anon$MenuSeparator$2);
        
        // Construct MenuItem quitItem
        quitItem = new JMenuItem();
        {
            class temp$quitItem$OnClickHandler implements ActionListener {
                public void actionPerformed(ActionEvent event) {
                    if (controller != null) controller.quit(quitItem, event);
                }
            }
            quitItem.addActionListener(new temp$quitItem$OnClickHandler());
        }
        quitItem.setText("Quit");
        quitItem.setMnemonic(KeyEvent.VK_Q);
        quitItem.setEnabled(true);
        fileMenu.add(quitItem);
        anon$MenuBar$0.add(fileMenu);
        
        // Construct Menu editMenu
        editMenu = new JMenu();
        editMenu.setText("Edit");
        editMenu.setMnemonic(KeyEvent.VK_E);
        
        // Construct MenuItem copyItem
        copyItem = new JMenuItem();
        {
            class temp$copyItem$OnClickHandler implements ActionListener {
                public void actionPerformed(ActionEvent event) {
                    if (controller != null) controller.copy(copyItem, event);
                }
            }
            copyItem.addActionListener(new temp$copyItem$OnClickHandler());
        }
        copyItem.setText("Copy");
        copyItem.setMnemonic(KeyEvent.VK_C);
        copyItem.setEnabled(true);
        editMenu.add(copyItem);
        
        // Construct MenuItem cutItem
        cutItem = new JMenuItem();
        {
            class temp$cutItem$OnClickHandler implements ActionListener {
                public void actionPerformed(ActionEvent event) {
                    if (controller != null) controller.cut(cutItem, event);
                }
            }
            cutItem.addActionListener(new temp$cutItem$OnClickHandler());
        }
        cutItem.setText("Cut");
        cutItem.setMnemonic(KeyEvent.VK_T);
        cutItem.setEnabled(true);
        editMenu.add(cutItem);
        
        // Construct MenuItem pasteItem
        pasteItem = new JMenuItem();
        {
            class temp$pasteItem$OnClickHandler implements ActionListener {
                public void actionPerformed(ActionEvent event) {
                    if (controller != null) controller.paste(pasteItem, event);
                }
            }
            pasteItem.addActionListener(new temp$pasteItem$OnClickHandler());
        }
        pasteItem.setText("Paste");
        pasteItem.setMnemonic(KeyEvent.VK_P);
        pasteItem.setEnabled(true);
        editMenu.add(pasteItem);
        
        // Construct MenuSeparator (anonymous)
        anon$MenuSeparator$3 = new JSeparator();
        editMenu.add(anon$MenuSeparator$3);
        
        // Construct MenuItem selElvisCodeItem
        selElvisCodeItem = new JMenuItem();
        {
            class temp$selElvisCodeItem$OnClickHandler implements ActionListener {
                public void actionPerformed(ActionEvent event) {
                    if (controller != null) controller.selElvis(selElvisCodeItem, event);
                }
            }
            selElvisCodeItem.addActionListener(new temp$selElvisCodeItem$OnClickHandler());
        }
        selElvisCodeItem.setText("Select All Elvis Code");
        selElvisCodeItem.setMnemonic(KeyEvent.VK_E);
        selElvisCodeItem.setEnabled(true);
        editMenu.add(selElvisCodeItem);
        
        // Construct MenuItem selJavaCodeItem
        selJavaCodeItem = new JMenuItem();
        {
            class temp$selJavaCodeItem$OnClickHandler implements ActionListener {
                public void actionPerformed(ActionEvent event) {
                    if (controller != null) controller.selJava(selJavaCodeItem, event);
                }
            }
            selJavaCodeItem.addActionListener(new temp$selJavaCodeItem$OnClickHandler());
        }
        selJavaCodeItem.setText("Select All Java Code");
        selJavaCodeItem.setMnemonic(KeyEvent.VK_J);
        selJavaCodeItem.setEnabled(true);
        editMenu.add(selJavaCodeItem);
        anon$MenuBar$0.add(editMenu);
        
        // Construct Menu helpMenu
        helpMenu = new JMenu();
        helpMenu.setText("Help");
        helpMenu.setMnemonic(KeyEvent.VK_H);
        
        // Construct MenuItem helpItem
        helpItem = new JMenuItem();
        {
            class temp$helpItem$OnClickHandler implements ActionListener {
                public void actionPerformed(ActionEvent event) {
                    if (controller != null) controller.help(helpItem, event);
                }
            }
            helpItem.addActionListener(new temp$helpItem$OnClickHandler());
        }
        helpItem.setText("Help...");
        helpItem.setMnemonic(KeyEvent.VK_H);
        helpItem.setEnabled(true);
        helpMenu.add(helpItem);
        
        // Construct MenuItem tutorialItem
        tutorialItem = new JMenuItem();
        {
            class temp$tutorialItem$OnClickHandler implements ActionListener {
                public void actionPerformed(ActionEvent event) {
                    if (controller != null) controller.tutorial(tutorialItem, event);
                }
            }
            tutorialItem.addActionListener(new temp$tutorialItem$OnClickHandler());
        }
        tutorialItem.setText("Tutorial");
        tutorialItem.setMnemonic(KeyEvent.VK_T);
        tutorialItem.setEnabled(true);
        helpMenu.add(tutorialItem);
        
        // Construct MenuSeparator (anonymous)
        anon$MenuSeparator$4 = new JSeparator();
        helpMenu.add(anon$MenuSeparator$4);
        
        // Construct MenuItem aboutItem
        aboutItem = new JMenuItem();
        {
            class temp$aboutItem$OnClickHandler implements ActionListener {
                public void actionPerformed(ActionEvent event) {
                    if (controller != null) controller.about(aboutItem, event);
                }
            }
            aboutItem.addActionListener(new temp$aboutItem$OnClickHandler());
        }
        aboutItem.setText("About...");
        aboutItem.setMnemonic(KeyEvent.VK_A);
        aboutItem.setEnabled(true);
        helpMenu.add(aboutItem);
        anon$MenuBar$0.add(helpMenu);
        window.setJMenuBar(anon$MenuBar$0);
        
        // Construct BorderLayout (anonymous)
        anon$BorderLayout$5 = new BorderLayout();
        anon$BorderLayout$5.setVgap(3);
        anon$BorderLayout$5.setVgap(3);
        // Construct Frame buttonBar
        buttonBar = new JPanel();
        
        // Construct RowLayout buttonRow
        buttonRow = new BoxLayout(buttonBar, BoxLayout.LINE_AXIS);
        
        // Construct Button compileButton
        compileButton = new JButton();
        {
            class temp$compileButton$OnClickHandler implements ActionListener {
                public void actionPerformed(ActionEvent event) {
                    if (controller != null) controller.compile(compileButton, event);
                }
            }
            compileButton.addActionListener(new temp$compileButton$OnClickHandler());
        }
        compileButton.setText("Compile");
        compileButton.setSelected(false);
        compileButton.setBorderPainted(true);
        compileButton.setContentAreaFilled(true);
        compileButton.setEnabled(true);
        compileButton.setHorizontalAlignment(0);
        compileButton.setVerticalAlignment(0);
        
        // Add compileButton to buttonRow
        compileButton.setAlignmentY(0.500000f);
        {
            final JPanel $_border = new JPanel();
            $_border.setLayout(new OverlayLayout($_border));
            $_border.setBorder(BorderFactory.createEmptyBorder(3, 3, 3, 3));
            $_border.setAlignmentY(0.500000f);
            $_border.add(compileButton);
            SPECIAL$buttonBar$layoutChildren.add($_border);
            SPECIAL$buttonBar$layoutConstraints.add(null);
        }
        
        // Construct CheckButton suppressModifiers
        suppressModifiers = new JCheckBox();
        {
            class temp$suppressModifiers$OnClickHandler implements ActionListener {
                public void actionPerformed(ActionEvent event) {
                    if (controller != null) controller.suppressModifiers(suppressModifiers, event);
                }
            }
            suppressModifiers.addActionListener(new temp$suppressModifiers$OnClickHandler());
        }
        suppressModifiers.setText("Suppress Modifiers");
        suppressModifiers.setSelected(false);
        suppressModifiers.setBorderPainted(false);
        suppressModifiers.setContentAreaFilled(true);
        suppressModifiers.setEnabled(true);
        suppressModifiers.setHorizontalAlignment(0);
        suppressModifiers.setVerticalAlignment(0);
        suppressModifiers.setBorderPaintedFlat(false);
        
        // Add suppressModifiers to buttonRow
        suppressModifiers.setAlignmentY(0.500000f);
        {
            final JPanel $_border = new JPanel();
            $_border.setLayout(new OverlayLayout($_border));
            $_border.setBorder(BorderFactory.createEmptyBorder(3, 3, 3, 3));
            $_border.setAlignmentY(0.500000f);
            $_border.add(suppressModifiers);
            SPECIAL$buttonBar$layoutChildren.add($_border);
            SPECIAL$buttonBar$layoutConstraints.add(null);
        }
        
        // Construct CheckButton executable
        executable = new JCheckBox();
        {
            class temp$executable$OnClickHandler implements ActionListener {
                public void actionPerformed(ActionEvent event) {
                    if (controller != null) controller.executable(executable, event);
                }
            }
            executable.addActionListener(new temp$executable$OnClickHandler());
        }
        executable.setText("Executable");
        executable.setSelected(false);
        executable.setBorderPainted(false);
        executable.setContentAreaFilled(true);
        executable.setEnabled(true);
        executable.setHorizontalAlignment(0);
        executable.setVerticalAlignment(0);
        executable.setBorderPaintedFlat(false);
        
        // Add executable to buttonRow
        executable.setAlignmentY(0.500000f);
        {
            final JPanel $_border = new JPanel();
            $_border.setLayout(new OverlayLayout($_border));
            $_border.setBorder(BorderFactory.createEmptyBorder(3, 3, 3, 3));
            $_border.setAlignmentY(0.500000f);
            $_border.add(executable);
            SPECIAL$buttonBar$layoutChildren.add($_border);
            SPECIAL$buttonBar$layoutConstraints.add(null);
        }
        
        // Construct Label (anonymous)
        anon$Label$6 = new JLabel();
        anon$Label$6.setText("Language:");
        
        // Add (anonymous Label) to buttonRow
        anon$Label$6.setAlignmentY(0.500000f);
        {
            final JPanel $_border = new JPanel();
            $_border.setLayout(new OverlayLayout($_border));
            $_border.setBorder(BorderFactory.createEmptyBorder(3, 3, 3, 3));
            $_border.setAlignmentY(0.500000f);
            $_border.add(anon$Label$6);
            SPECIAL$buttonBar$layoutChildren.add($_border);
            SPECIAL$buttonBar$layoutConstraints.add(null);
        }
        
        // Construct ComboBox comboBox
        comboBox = new JComboBox();
        comboBox.addItem((String) "Java");
        comboBox.addItem((String) "C++");
        comboBox.addItem((String) "C");
        
        // Add comboBox to buttonRow
        comboBox.setAlignmentY(0.500000f);
        {
            final JPanel $_border = new JPanel();
            $_border.setLayout(new OverlayLayout($_border));
            $_border.setBorder(BorderFactory.createEmptyBorder(3, 3, 3, 3));
            $_border.setAlignmentY(0.500000f);
            $_border.add(comboBox);
            SPECIAL$buttonBar$layoutChildren.add($_border);
            SPECIAL$buttonBar$layoutConstraints.add(null);
        }
        
        // Construct Button runButton
        runButton = new JButton();
        {
            class temp$runButton$OnClickHandler implements ActionListener {
                public void actionPerformed(ActionEvent event) {
                    if (controller != null) controller.run(runButton, event);
                }
            }
            runButton.addActionListener(new temp$runButton$OnClickHandler());
        }
        runButton.setText("Run");
        runButton.setSelected(false);
        runButton.setBorderPainted(true);
        runButton.setContentAreaFilled(true);
        runButton.setEnabled(true);
        runButton.setHorizontalAlignment(0);
        runButton.setVerticalAlignment(0);
        
        // Add runButton to buttonRow
        runButton.setAlignmentY(0.500000f);
        {
            final JPanel $_border = new JPanel();
            $_border.setLayout(new OverlayLayout($_border));
            $_border.setBorder(BorderFactory.createEmptyBorder(3, 3, 3, 3));
            $_border.setAlignmentY(0.500000f);
            $_border.add(runButton);
            SPECIAL$buttonBar$layoutChildren.add($_border);
            SPECIAL$buttonBar$layoutConstraints.add(null);
        }
        
        // Construct Spacer (anonymous)
        anon$Spacer$7 = Box.createHorizontalGlue();
        
        // Add (anonymous Spacer) to buttonRow
        SPECIAL$buttonBar$layoutChildren.add(anon$Spacer$7);
        SPECIAL$buttonBar$layoutConstraints.add(null);
        if (!AUX$buttonBar$hasLayout) {
            AUX$buttonBar$layout = buttonRow;
            AUX$buttonBar$hasLayout = true;
        }
        buttonBar.setLayout(AUX$buttonBar$layout);
        for (int $_ix = 0; $_ix < SPECIAL$buttonBar$layoutChildren.size(); $_ix++) {
            Component $_layoutChild = SPECIAL$buttonBar$layoutChildren.get($_ix);
            Object $_layoutConstraint = SPECIAL$buttonBar$layoutConstraints.get($_ix);
            if ($_layoutConstraint == null) {
                buttonBar.add($_layoutChild);
            } else {
                buttonBar.add($_layoutChild, $_layoutConstraint);
            }
        }
        
        // Add buttonBar to (anonymous BorderLayout)
        SPECIAL$window$layoutChildren.add(buttonBar);
        SPECIAL$window$layoutConstraints.add(BorderLayout.PAGE_START);
        
        // Construct Frame (anonymous)
        anon$Frame$8 = new JPanel();
        
        // Construct ColumnLayout (anonymous)
        anon$ColumnLayout$9 = new BoxLayout(anon$Frame$8, BoxLayout.PAGE_AXIS);
        
        // Construct ScrollingFrame (anonymous)
        anon$ScrollingFrame$10 = new JScrollPane();
        
        // Construct Tree tree
        AUX$tree$root = new DefaultMutableTreeNode();
        tree = new JTree(AUX$tree$root);
        {
            final Component temp$tree = tree;
            final Controller temp$controller = controller;
            class temp$tree$onSelectedHandler implements TreeSelectionListener {
                public void valueChanged(TreeSelectionEvent event) {
                    if (temp$controller != null) temp$controller.documentation(temp$tree, event);
                }
            }
            tree.addTreeSelectionListener(new temp$tree$onSelectedHandler());
        }
        tree.expandRow(0);
        tree.validate();
        anon$ScrollingFrame$10.setViewportView(tree);
        
        // Add (anonymous ScrollingFrame) to (anonymous ColumnLayout)
        anon$ScrollingFrame$10.setAlignmentY(0.500000f);
        {
            final JPanel $_border = new JPanel();
            $_border.setLayout(new OverlayLayout($_border));
            $_border.setBorder(BorderFactory.createEmptyBorder(3, 3, 3, 3));
            $_border.setAlignmentY(0.500000f);
            $_border.add(anon$ScrollingFrame$10);
            SPECIAL$anon$Frame$8$layoutChildren.add($_border);
            SPECIAL$anon$Frame$8$layoutConstraints.add(null);
        }
        
        // Construct ScrollingFrame docFrame
        docFrame = new JScrollPane();
        
        // Construct TextArea docViewer
        docViewer = new JTextArea();
        docViewer.setRows(13);
        docViewer.setColumns(20);
        docViewer.setText("Document Viewer.");
        docViewer.setLineWrap(true);
        docViewer.setWrapStyleWord(true);
        docViewer.setEditable(false);
        docFrame.setViewportView(docViewer);
        
        // Add docFrame to (anonymous ColumnLayout)
        docFrame.setAlignmentY(0.500000f);
        {
            final JPanel $_border = new JPanel();
            $_border.setLayout(new OverlayLayout($_border));
            $_border.setBorder(BorderFactory.createEmptyBorder(3, 3, 3, 3));
            $_border.setAlignmentY(0.500000f);
            $_border.add(docFrame);
            SPECIAL$anon$Frame$8$layoutChildren.add($_border);
            SPECIAL$anon$Frame$8$layoutConstraints.add(null);
        }
        if (!AUX$anon$Frame$8$hasLayout) {
            AUX$anon$Frame$8$layout = anon$ColumnLayout$9;
            AUX$anon$Frame$8$hasLayout = true;
        }
        anon$Frame$8.setLayout(AUX$anon$Frame$8$layout);
        for (int $_ix = 0; $_ix < SPECIAL$anon$Frame$8$layoutChildren.size(); $_ix++) {
            Component $_layoutChild = SPECIAL$anon$Frame$8$layoutChildren.get($_ix);
            Object $_layoutConstraint = SPECIAL$anon$Frame$8$layoutConstraints.get($_ix);
            if ($_layoutConstraint == null) {
                anon$Frame$8.add($_layoutChild);
            } else {
                anon$Frame$8.add($_layoutChild, $_layoutConstraint);
            }
        }
        
        // Add (anonymous Frame) to (anonymous BorderLayout)
        SPECIAL$window$layoutChildren.add(anon$Frame$8);
        SPECIAL$window$layoutConstraints.add(BorderLayout.LINE_START);
        
        // Construct Frame (anonymous)
        anon$Frame$11 = new JPanel();
        
        // Construct RowLayout (anonymous)
        anon$RowLayout$12 = new BoxLayout(anon$Frame$11, BoxLayout.LINE_AXIS);
        
        // Construct Frame (anonymous)
        anon$Frame$13 = new JPanel();
        
        // Construct ColumnLayout (anonymous)
        anon$ColumnLayout$14 = new BoxLayout(anon$Frame$13, BoxLayout.PAGE_AXIS);
        
        // Construct Label elvisDocName
        elvisDocName = new JLabel();
        elvisDocName.setText("");
        
        // Add elvisDocName to (anonymous ColumnLayout)
        elvisDocName.setAlignmentY(0.500000f);
        {
            final JPanel $_border = new JPanel();
            $_border.setLayout(new OverlayLayout($_border));
            $_border.setBorder(BorderFactory.createEmptyBorder(3, 3, 3, 3));
            $_border.setAlignmentY(0.500000f);
            $_border.add(elvisDocName);
            SPECIAL$anon$Frame$13$layoutChildren.add($_border);
            SPECIAL$anon$Frame$13$layoutConstraints.add(null);
        }
        
        // Construct ScrollingFrame (anonymous)
        anon$ScrollingFrame$15 = new JScrollPane();
        
        // Construct TextArea elvisText
        elvisText = new SmartTextArea();
        elvisText.accessibleTextComponent.setRows(36);
        elvisText.accessibleTextComponent.setColumns(30);
        elvisText.accessibleTextComponent.setText("Enter Elvis code here");
        elvisText.accessibleTextComponent.setLineWrap(false);
        elvisText.accessibleTextComponent.setEditable(true);
        anon$ScrollingFrame$15.setViewportView(elvisText);
        
        // Add (anonymous ScrollingFrame) to (anonymous ColumnLayout)
        anon$ScrollingFrame$15.setAlignmentY(0.500000f);
        {
            final JPanel $_border = new JPanel();
            $_border.setLayout(new OverlayLayout($_border));
            $_border.setBorder(BorderFactory.createEmptyBorder(3, 3, 3, 3));
            $_border.setAlignmentY(0.500000f);
            $_border.add(anon$ScrollingFrame$15);
            SPECIAL$anon$Frame$13$layoutChildren.add($_border);
            SPECIAL$anon$Frame$13$layoutConstraints.add(null);
        }
        if (!AUX$anon$Frame$13$hasLayout) {
            AUX$anon$Frame$13$layout = anon$ColumnLayout$14;
            AUX$anon$Frame$13$hasLayout = true;
        }
        anon$Frame$13.setLayout(AUX$anon$Frame$13$layout);
        for (int $_ix = 0; $_ix < SPECIAL$anon$Frame$13$layoutChildren.size(); $_ix++) {
            Component $_layoutChild = SPECIAL$anon$Frame$13$layoutChildren.get($_ix);
            Object $_layoutConstraint = SPECIAL$anon$Frame$13$layoutConstraints.get($_ix);
            if ($_layoutConstraint == null) {
                anon$Frame$13.add($_layoutChild);
            } else {
                anon$Frame$13.add($_layoutChild, $_layoutConstraint);
            }
        }
        
        // Add (anonymous Frame) to (anonymous RowLayout)
        anon$Frame$13.setAlignmentY(0.500000f);
        {
            final JPanel $_border = new JPanel();
            $_border.setLayout(new OverlayLayout($_border));
            $_border.setBorder(BorderFactory.createEmptyBorder(3, 3, 3, 3));
            $_border.setAlignmentY(0.500000f);
            $_border.add(anon$Frame$13);
            SPECIAL$anon$Frame$11$layoutChildren.add($_border);
            SPECIAL$anon$Frame$11$layoutConstraints.add(null);
        }
        
        // Construct Frame (anonymous)
        anon$Frame$16 = new JPanel();
        
        // Construct ColumnLayout (anonymous)
        anon$ColumnLayout$17 = new BoxLayout(anon$Frame$16, BoxLayout.PAGE_AXIS);
        
        // Construct Label javaDocName
        javaDocName = new JLabel();
        javaDocName.setText("");
        
        // Add javaDocName to (anonymous ColumnLayout)
        javaDocName.setAlignmentY(0.500000f);
        {
            final JPanel $_border = new JPanel();
            $_border.setLayout(new OverlayLayout($_border));
            $_border.setBorder(BorderFactory.createEmptyBorder(3, 3, 3, 3));
            $_border.setAlignmentY(0.500000f);
            $_border.add(javaDocName);
            SPECIAL$anon$Frame$16$layoutChildren.add($_border);
            SPECIAL$anon$Frame$16$layoutConstraints.add(null);
        }
        
        // Construct ScrollingFrame (anonymous)
        anon$ScrollingFrame$18 = new JScrollPane();
        
        // Construct TextArea javaText
        javaText = new SmartTextArea();
        javaText.accessibleTextComponent.setRows(36);
        javaText.accessibleTextComponent.setColumns(30);
        javaText.accessibleTextComponent.setText("Java code will show up here");
        javaText.accessibleTextComponent.setLineWrap(false);
        javaText.accessibleTextComponent.setEditable(false);
        anon$ScrollingFrame$18.setViewportView(javaText);
        
        // Add (anonymous ScrollingFrame) to (anonymous ColumnLayout)
        anon$ScrollingFrame$18.setAlignmentY(0.500000f);
        {
            final JPanel $_border = new JPanel();
            $_border.setLayout(new OverlayLayout($_border));
            $_border.setBorder(BorderFactory.createEmptyBorder(3, 3, 3, 3));
            $_border.setAlignmentY(0.500000f);
            $_border.add(anon$ScrollingFrame$18);
            SPECIAL$anon$Frame$16$layoutChildren.add($_border);
            SPECIAL$anon$Frame$16$layoutConstraints.add(null);
        }
        if (!AUX$anon$Frame$16$hasLayout) {
            AUX$anon$Frame$16$layout = anon$ColumnLayout$17;
            AUX$anon$Frame$16$hasLayout = true;
        }
        anon$Frame$16.setLayout(AUX$anon$Frame$16$layout);
        for (int $_ix = 0; $_ix < SPECIAL$anon$Frame$16$layoutChildren.size(); $_ix++) {
            Component $_layoutChild = SPECIAL$anon$Frame$16$layoutChildren.get($_ix);
            Object $_layoutConstraint = SPECIAL$anon$Frame$16$layoutConstraints.get($_ix);
            if ($_layoutConstraint == null) {
                anon$Frame$16.add($_layoutChild);
            } else {
                anon$Frame$16.add($_layoutChild, $_layoutConstraint);
            }
        }
        
        // Add (anonymous Frame) to (anonymous RowLayout)
        anon$Frame$16.setAlignmentY(0.500000f);
        {
            final JPanel $_border = new JPanel();
            $_border.setLayout(new OverlayLayout($_border));
            $_border.setBorder(BorderFactory.createEmptyBorder(3, 3, 3, 3));
            $_border.setAlignmentY(0.500000f);
            $_border.add(anon$Frame$16);
            SPECIAL$anon$Frame$11$layoutChildren.add($_border);
            SPECIAL$anon$Frame$11$layoutConstraints.add(null);
        }
        if (!AUX$anon$Frame$11$hasLayout) {
            AUX$anon$Frame$11$layout = anon$RowLayout$12;
            AUX$anon$Frame$11$hasLayout = true;
        }
        anon$Frame$11.setLayout(AUX$anon$Frame$11$layout);
        for (int $_ix = 0; $_ix < SPECIAL$anon$Frame$11$layoutChildren.size(); $_ix++) {
            Component $_layoutChild = SPECIAL$anon$Frame$11$layoutChildren.get($_ix);
            Object $_layoutConstraint = SPECIAL$anon$Frame$11$layoutConstraints.get($_ix);
            if ($_layoutConstraint == null) {
                anon$Frame$11.add($_layoutChild);
            } else {
                anon$Frame$11.add($_layoutChild, $_layoutConstraint);
            }
        }
        
        // Add (anonymous Frame) to (anonymous BorderLayout)
        SPECIAL$window$layoutChildren.add(anon$Frame$11);
        SPECIAL$window$layoutConstraints.add(BorderLayout.CENTER);
        
        // Construct Frame bottomRow
        bottomRow = new JPanel();
        
        // Construct ScrollingFrame errorPane
        errorPane = new JScrollPane();
        
        // Construct TextArea errorText
        errorText = new JTextArea();
        errorText.setRows(5);
        errorText.setColumns(80);
        errorText.setText("Error Box.");
        errorText.setLineWrap(true);
        errorText.setWrapStyleWord(true);
        errorText.setEditable(false);
        errorPane.setViewportView(errorText);
        bottomRow.add(errorPane);
        for (int $_ix = 0; $_ix < SPECIAL$bottomRow$layoutChildren.size(); $_ix++) {
            Component $_layoutChild = SPECIAL$bottomRow$layoutChildren.get($_ix);
            Object $_layoutConstraint = SPECIAL$bottomRow$layoutConstraints.get($_ix);
            if ($_layoutConstraint == null) {
                bottomRow.add($_layoutChild);
            } else {
                bottomRow.add($_layoutChild, $_layoutConstraint);
            }
        }
        
        // Add bottomRow to (anonymous BorderLayout)
        SPECIAL$window$layoutChildren.add(bottomRow);
        SPECIAL$window$layoutConstraints.add(BorderLayout.PAGE_END);
        if (!AUX$window$hasLayout) {
            AUX$window$layout = anon$BorderLayout$5;
            AUX$window$hasLayout = true;
        }
        window.setLayout(AUX$window$layout);
        for (int $_ix = 0; $_ix < SPECIAL$window$layoutChildren.size(); $_ix++) {
            Component $_layoutChild = SPECIAL$window$layoutChildren.get($_ix);
            Object $_layoutConstraint = SPECIAL$window$layoutConstraints.get($_ix);
            if ($_layoutConstraint == null) {
                window.add($_layoutChild);
            } else {
                window.add($_layoutChild, $_layoutConstraint);
            }
        }
        if (!AUX$window$hasLayout) {
            window.setLayout(new FlowLayout());
        }
        window.setVisible(true);
        window.pack();
        
        // Construct FileChooser fileChooser
        this.fileChooser = new JFileChooser();
        fileChooser.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);
        fileChooser.addChoosableFileFilter(new Filter("Elvis source file", ".gui"));
        fileChooser.setAcceptAllFileFilterUsed(true);
        fileChooser.setMultiSelectionEnabled(false);
        fileChooser.setFileHidingEnabled(true);
        
        // Construct DialogBox about
        
        // Construct DialogBox help
        
        // Construct DialogBox tutorial
    }
    public JPanel bottomRow;
    private JSeparator anon$MenuSeparator$1;
    private boolean AUX$anon$Frame$11$hasLayout = false;
    public JPanel buttonBar;
    public JMenuItem aboutItem;
    public JButton runButton;
    private LayoutManager AUX$bottomRow$layout;
    public JMenuItem pasteItem;
    private boolean AUX$anon$Frame$8$hasLayout = false;
    private JSeparator anon$MenuSeparator$3;
    public BoxLayout buttonRow;
    private BoxLayout anon$ColumnLayout$14;
    public JMenuItem cutItem;
    private final List<Component> SPECIAL$anon$Frame$11$layoutChildren =
        new ArrayList<Component>();
    private boolean AUX$window$hasLayout = false;
    public JScrollPane errorPane;
    public JMenuItem saveItem;
    private LayoutManager AUX$anon$Frame$8$layout;
    public JMenuItem tutorialItem;
    public JTextArea errorText;
    private final List<Component> SPECIAL$anon$Frame$8$layoutChildren =
        new ArrayList<Component>();
    public JMenuItem selJavaCodeItem;
    private final List<Component> SPECIAL$window$layoutChildren =
        new ArrayList<Component>();
    public DefaultMutableTreeNode AUX$tree$root;
    public SmartTextArea elvisText;
    private JLabel anon$Label$6;
    public JFileChooser fileChooser;
    private BoxLayout anon$ColumnLayout$9;
    private final List<Component> SPECIAL$bottomRow$layoutChildren =
        new ArrayList<Component>();
    private BoxLayout anon$RowLayout$12;
    private boolean AUX$bottomRow$hasLayout = false;
    public JMenuItem copyItem;
    public JMenu editMenu;
    private boolean AUX$anon$Frame$16$hasLayout = false;
    public JMenuItem helpItem;
    public JMenuItem openItem;
    public JTextArea docViewer;
    private LayoutManager AUX$anon$Frame$16$layout;
    private final List<Object> SPECIAL$buttonBar$layoutConstraints =
        new ArrayList<Object>();
    public JCheckBox suppressModifiers;
    private JScrollPane anon$ScrollingFrame$10;
    private JPanel anon$Frame$8;
    private final List<Object> SPECIAL$window$layoutConstraints =
        new ArrayList<Object>();
    public JButton compileButton;
    public JMenuItem newItem;
    private final List<Object> SPECIAL$anon$Frame$13$layoutConstraints =
        new ArrayList<Object>();
    private JPanel anon$Frame$16;
    public JCheckBox executable;
    public JMenu helpMenu;
    private LayoutManager AUX$window$layout;
    private final List<Component> SPECIAL$anon$Frame$16$layoutChildren =
        new ArrayList<Component>();
    private boolean AUX$buttonBar$hasLayout = false;
    private boolean AUX$anon$Frame$13$hasLayout = false;
    public JLabel elvisDocName;
    private LayoutManager AUX$anon$Frame$13$layout;
    public JFrame window;
    public JLabel javaDocName;
    private final List<Component> SPECIAL$anon$Frame$13$layoutChildren =
        new ArrayList<Component>();
    public JMenu fileMenu;
    private Component anon$Spacer$7;
    public JComboBox comboBox;
    public JMenuItem quitItem;
    private LayoutManager AUX$buttonBar$layout;
    public JMenuItem saveAsItem;
    private final List<Object> SPECIAL$anon$Frame$11$layoutConstraints =
        new ArrayList<Object>();
    public JTree tree;
    private JScrollPane anon$ScrollingFrame$18;
    private BoxLayout anon$ColumnLayout$17;
    private final List<Object> SPECIAL$anon$Frame$16$layoutConstraints =
        new ArrayList<Object>();
    private BorderLayout anon$BorderLayout$5;
    public JMenuItem selElvisCodeItem;
    private JSeparator anon$MenuSeparator$4;
    private JMenuBar anon$MenuBar$0;
    private LayoutManager AUX$anon$Frame$11$layout;
    private final List<Object> SPECIAL$bottomRow$layoutConstraints =
        new ArrayList<Object>();
    private final List<Object> SPECIAL$anon$Frame$8$layoutConstraints =
        new ArrayList<Object>();
    private JScrollPane anon$ScrollingFrame$15;
    private JPanel anon$Frame$11;
    private JSeparator anon$MenuSeparator$2;
    private JPanel anon$Frame$13;
    private final List<Component> SPECIAL$buttonBar$layoutChildren =
        new ArrayList<Component>();
    public JScrollPane docFrame;
    public SmartTextArea javaText;
    public Color getButtonBackgroundColor(JButton button) {
    	return button.getBackground();
    }
    public void setButtonBackgroundColor(JButton button, Color newColor) {
    	button.setBackground(newColor);
    }
    public boolean getTextAreaEditable(JTextArea area) {
    	return area.isEditable();
    }
    public void setTextAreaEditable(JTextArea area, boolean newEditable) {
    	area.setEditable(newEditable);
    }
    public int getLabelVerticalAlignment(JLabel label) {
    	return label.getVerticalAlignment();
    }
    public void setLabelVerticalAlignment(JLabel label, int newAlignment) {
    	label.setVerticalAlignment(newAlignment);
    }
    public FileChooserAnswer runFileChooserAsSave(JFileChooser chooser, Component window) {
       switch (chooser.showSaveDialog(window)) {
           case JFileChooser.CANCEL_OPTION:
               return FileChooserAnswer.CANCEL;
           case JFileChooser.APPROVE_OPTION:
               return FileChooserAnswer.OK;
           default:
               return FileChooserAnswer.ERROR;
       }
    }
    public void setFileChooserDirectory(JFileChooser chooser, String directory) {
       chooser.setCurrentDirectory(new File(directory));
    }
    public boolean getTextAreaLineWrap(SmartTextArea area) {
    	return area.accessibleTextComponent.getLineWrap();
    }
    public void setTextAreaLineWrap(SmartTextArea area, boolean newLineWrap) {
    	area.accessibleTextComponent.setLineWrap(newLineWrap);
    }
    public int getWindowWidth(JFrame window) {
        return window.getWidth();
    }
    public void setWindowWidth(JFrame window, int newWidth) {
        Dimension newDimension = new Dimension(newWidth,window.getHeight());
        window.setPreferredSize(newDimension);
    }
    public FileChooserAnswer runFileChooserAsOpen(JFileChooser chooser, Component window) {
       switch (chooser.showOpenDialog(window)) {
           case JFileChooser.CANCEL_OPTION:
               return FileChooserAnswer.CANCEL;
           case JFileChooser.APPROVE_OPTION:
               return FileChooserAnswer.OK;
           default:
               return FileChooserAnswer.ERROR;
       }
    }
    public void triggeraboutDialog(){
    	JOptionPane.showMessageDialog(null,"\tELVIS is the product of a 2006 Carleton CS Comps research project designed to simplify the coding of GUIs. \nBrought to you by Luke Maurer, Tyler Odean, Anna Ritz, and Taylor Valore, and with the help of faculty advisor Amy Csizmar Dalal.","About ELVIS",JOptionPane.PLAIN_MESSAGE);
    }
    public String getFileChooserDirectory(JFileChooser chooser) {
        return chooser.getCurrentDirectory().getPath();
    }
    public String getButtonLabel(JButton button) {
    	return button.getText();
    }
    public void setButtonLabel(JButton button, String newLabel) {
    	button.setText(newLabel);
    }
    public void triggerhelpDialog(){
    	JOptionPane.showMessageDialog(null,"So far we're very unhelpful.","Help with ELVIS",JOptionPane.PLAIN_MESSAGE);
    }
    public void triggerhelpDialog(String message){
    	JOptionPane.showMessageDialog(null,message,"Help with ELVIS",JOptionPane.PLAIN_MESSAGE);
    }
    public Color getWindowBackgroundColor(JFrame window) {
        return window.getBackground();
    }
    public void setWindowBackgroundColor(JFrame window, Color newBackgroundColor) {
        window.setBackground(newBackgroundColor);
    }
    public boolean getTextAreaEditable(SmartTextArea area) {
    	return area.accessibleTextComponent.isEditable();
    }
    public void setTextAreaEditable(SmartTextArea area, boolean newEditable) {
    	area.accessibleTextComponent.setEditable(newEditable);
    }
    public int getButtonVerticalAlignment(JButton button) {
    	return button.getVerticalAlignment();
    }
    public void setButtonVerticalAlignment(JButton button, int newAlignment) {
    	button.setVerticalAlignment(newAlignment);
    }
    public int getTextAreaWidth(JTextArea area) {
    	return area.getColumns();
    }
    public void setTextAreaWidth(JTextArea area, int newWidth) {
    	area.setColumns(newWidth);
    }
    public int getTextAreaWidth(SmartTextArea area) {
    	return area.accessibleTextComponent.getColumns();
    }
    public void setTextAreaWidth(SmartTextArea area, int newWidth) {
    	area.accessibleTextComponent.setColumns(newWidth);
    }
    public int getScrollingFrameHeight(JScrollPane scrollingFrame) {
        return scrollingFrame.getHeight();
    }
    public void setScrollingFrameHeight(JScrollPane scrollingFrame, int newHeight) {
        Dimension newDimension = new Dimension(scrollingFrame.getWidth(),newHeight);
        scrollingFrame.setPreferredSize(newDimension);
    }
    public int getTextAreaHeight(SmartTextArea area) {
    	return area.accessibleTextComponent.getRows();
    }
    public void setTextAreaHeight(SmartTextArea area, int newHeight) {
    	area.accessibleTextComponent.setRows(newHeight);
    }
    public void setFileChooserTitle(JFileChooser chooser, String title) {
       chooser.setDialogTitle(title);
    }
    public int getTextAreaHeight(JTextArea area) {
    	return area.getRows();
    }
    public void setTextAreaHeight(JTextArea area, int newHeight) {
    	area.setRows(newHeight);
    }
    public Boolean getButtonContentAreaFilled(JButton button) {
    	return button.isContentAreaFilled();
    }
    public void setButtonContentAreaFilled(JButton button, boolean newContentAreaFilled) {
    	button.setContentAreaFilled(newContentAreaFilled);
    }
    public int getButtonWidth(JButton button) {
    	return button.getWidth();
    }
    public void setButtonWidth(JButton button, int newWidth) {
    	Dimension newDimension = new Dimension(newWidth,button.getHeight());
    	button.setPreferredSize(newDimension);
    }
    public int getWindowOnClose(JFrame window) {
        return window.getDefaultCloseOperation();
    }
    public void setWindowOnClose(JFrame window, int newClose) {
        window.setDefaultCloseOperation(newClose);
    }
    public int getMenuMnemonic(JMenu menu) {
    	return menu.getMnemonic();
    }
    public void setMenuMnemonic(JMenu menu, int newMnemonic) {
    	menu.setMnemonic(newMnemonic);
    }
    public Boolean getButtonSelected(JButton button) {
    	return button.isSelected();
    }
    public void setButtonSelected(JButton button, boolean newSelected) {
    	button.setSelected(newSelected);
    }
    public int getLabelHorizontalAlignement(JLabel label) {
    	return label.getHorizontalAlignment();
    }
    public void setLabelHorizontalAlignment(JLabel label, int newAlignment) {
    	label.setHorizontalAlignment(newAlignment);
    }
    public String getMenuText(JMenu menu) {
    	return menu.getText();
    }
    public void setMenuText(JMenu menu, String newText) {
    	menu.setText(newText);
    }
    public int getWindowHeight(JFrame window) {
        return window.getHeight();
    }
    public void setWindowHeight(JFrame window, int newHeight) {
        Dimension newDimension = new Dimension(window.getWidth(),newHeight);
        window.setPreferredSize(newDimension);
    }
    public int getButtonHeight(JButton button) {
    	return button.getHeight();
    }
    public void setButtonHeight(JButton button, int newHeight) {
    	Dimension newDimension = new Dimension(button.getWidth(),newHeight);
    	button.setPreferredSize(newDimension);
    }
    public String getWindowTitle(JFrame window) {
        return window.getTitle();
    }
    public void setWindowTitle(JFrame window, String newTitle) {
        window.setTitle(newTitle);
    }
    public String getTextAreaText(JTextArea area) {
    	return area.getText();
    }
    public void setTextAreaText(JTextArea area, String newText) {
    	area.setText(newText);
    }
    public Boolean getButtonEnabled(JButton button) {
    	return button.isEnabled();
    }
    public void setButtonEnabled(JButton button, boolean newEnabled) {
    	button.setEnabled(newEnabled);
    }
    public String getFileChooserSelectedFile(JFileChooser chooser) {
       return chooser.getSelectedFile().getPath();
    }
    public String getFileChooserTitle(JFileChooser chooser) {
        return chooser.getDialogTitle();
    }
    public void triggeraboutDialog(String message){
    	JOptionPane.showMessageDialog(null,message,"About ELVIS",JOptionPane.PLAIN_MESSAGE);
    }
    public void triggertutorialDialog(String message){
    	JOptionPane.showMessageDialog(null,message,"ELVIS Tutorial",JOptionPane.PLAIN_MESSAGE);
    }
    public void triggertutorialDialog(){
    	JOptionPane.showMessageDialog(null,"Open and edit your .gui file on the left, then press 'compile' to see it generated into your destination language on the right.  Click 'run' to run your program.","ELVIS Tutorial",JOptionPane.PLAIN_MESSAGE);
    }
    public String getLabelText(JLabel label) {
    	return label.getText();
    }
    public void setLabelText(JLabel label, String newText) {
    	label.setText(newText);
    }
    public String getTextAreaText(SmartTextArea area) {
    	return area.accessibleTextComponent.getText();
    }
    public void setTextAreaText(SmartTextArea area, String newText) {
    	area.accessibleTextComponent.setText(newText);
    }
    public int getScrollingFrameWidth(JScrollPane scrollingFrame) {
        return scrollingFrame.getWidth();
    }
    public void setScrollingFrameWidth(JScrollPane scrollingFrame, int newWidth) {
        Dimension newDimension = new Dimension(newWidth,scrollingFrame.getHeight());
        scrollingFrame.setPreferredSize(newDimension);
    }
    public boolean getWindowResizable(JFrame window) {
        return window.isResizable();
    }
    public void setWindowResizable(JFrame window, boolean newResizable) {
        window.setResizable(newResizable);
    }
    public LayoutManager getWindowLayout(JFrame window) {
        return window.getLayout();
    }
    public void setWindowLayout(JFrame window, LayoutManager newLayout) {
        window.setLayout(newLayout);
    }
    public int getFrameHeight(JPanel frame) {
        return frame.getHeight();
    }
    public void setFrameHeight(JPanel frame, int newHeight) {
        Dimension newDimension = new Dimension(frame.getWidth(),newHeight);
        frame.setPreferredSize(newDimension);
    }
    public String[] getFileChooserSelectedFiles(JFileChooser chooser) {
       final File[] files = chooser.getSelectedFiles();
       final String[] ans = new String[files.length];
       int ix = 0;
       for (File file : files)
           ans[ix++] = file.getPath();
       return ans;
    }
    public String getMenuItemLabel(JMenuItem menuitem) {
    	return menuitem.getText();
    }
    public void setMenuItemLabel(JMenuItem menuItem, String newLabel) {
    	menuItem.setText(newLabel);
    }
    public int getButtonHorizontalAlignement(JButton button) {
    	return button.getHorizontalAlignment();
    }
    public void setButtonHorizontalAlignment(JButton button, int newAlignment) {
    	button.setHorizontalAlignment(newAlignment);
    }
    public boolean getCheckBoxBorderOutline(JCheckBox checkbutton) {
    	return checkbutton.isBorderPaintedFlat();
    }
    public void setCheckBoxBorderOutline(JCheckBox checkbutton, boolean newOutline) {
    checkbutton.setBorderPaintedFlat(newOutline);
    }
    public Boolean getButtonBorderPainted(JButton button) {
    	return button.isBorderPainted();
    }
    public void setButtonBorderPainted(JButton button, boolean newBorderPainted) {
    	button.setBorderPainted(newBorderPainted);
    }
    public int getFrameWidth(JPanel frame) {
        return frame.getWidth();
    }
    public void setFrameWidth(JPanel frame, int newWidth) {
        Dimension newDimension = new Dimension(newWidth,frame.getHeight());
        frame.setPreferredSize(newDimension);
    }
    public Color getFrameBackgroundColor(JPanel frame) {
        return frame.getBackground();
    }
    public void setFrameBackgroundColor(JPanel frame, Color newBackgroundColor) {
        frame.setBackground(newBackgroundColor);
    }
    public String getButtonText(JButton button) {
    	return getButtonLabel(button);
    }
    public void setButtonText(JButton button, String newText) {
    	setButtonLabel(button, newText);
    }
    public boolean getTextAreaLineWrap(JTextArea area) {
    	return area.getLineWrap();
    }
    public void setTextAreaLineWrap(JTextArea area, boolean newLineWrap) {
    	area.setLineWrap(newLineWrap);
    }
    public static enum FileChooserAnswer {
        OK, CANCEL, ERROR
    }
    /*
     * Name: SmartTextArea
     * Description:A utility tool I can call this JComponent.
     * I hated JTextArea that it does not have internal capability of displaying line numbers, and one click line selection.
     * I needed when I was developing an ide for MIPS language as source code editor.
     * Use it like your own :)
     * By: Fatih Keles
     * 
    *
     * Inputs:several constructers are available but empty constructer works fine too.
     * Also has a test main method inside code
    *
     *  Returns:A JPanel that can be plugged anywhere.
     *
     * Assumes:One constructer also takes a java.awt.Point in it that is updated as x has the line number, y has the char number in text area.
     * may be usefull to follw caret positions as I used for that purpose
    *
    * Side Effects:not known
     * This code is copyrighted and has limited warranties.
    * Please see http://www.Planet-Source-Code.com/xq/ASP/txtCodeId.5095/lngWId.2/qx/vb/scripts/ShowCode.htm
    * for details.
    */
    /**
    *SmartArea.java is a somehow skilled java text component.
    *Pluggable into any swing application.
    *I did not made the awt compatibility tests yet.
    *if anyone improves or makes changes over this
    *please send me a copy to: fatihkeles@gmail.com
    *It can show the text with line numbers, and select entire
    *row by clicking number pane on left;
    */
    /*
    *@author fkeles
    *@version 0.1 Key listener for numbering & caret listener used for display and selection
    *@version 0.2 key listener replaced with document listener
    *
    */
    public class SmartTextArea extends JPanel{
        	private JTextArea accessibleTextComponent;
    		private NumberPane numberPane;
        	private JScrollPane scroller;
        	private JPanel rootPane,contentPane;
        	private Point caretPosition;
           	public SmartTextArea(){
           		contentPane=new JPanel(new BorderLayout());
           		scroller=new JScrollPane(contentPane);
           		accessibleTextComponent=new JTextArea();
           		numberPane=new NumberPane();
           		rootPane=this;
           		caretPosition=new Point();
    			super.setLayout(new GridLayout(1,1));
           		contentPane.add(accessibleTextComponent,BorderLayout.CENTER);
           		contentPane.add(numberPane,BorderLayout.WEST);
           		rootPane.add(scroller);
           	}
            public SmartTextArea(Point caretReports){
               	this();
               	caretPosition=caretReports;
            }
           	public SmartTextArea(String text){
           		this();
           		setText(text);
           	}
           	public JTextArea getAccessibleTextComponent(){
           		return accessibleTextComponent;
          	}
             public String getText(){
               	return accessibleTextComponent.getText();
             }
             public void setText(String text){
             	accessibleTextComponent.setText(text);
             }
             public int getRowCount(){
             	return accessibleTextComponent.getRows();
             }
    		public void append(String text){
    			accessibleTextComponent.append(text);
    		}
    		public void copy(){
    			accessibleTextComponent.copy();
    		}
    		public String getSelectedText(){
    			return accessibleTextComponent.getSelectedText();
    		}
    		public void cut(){
    			accessibleTextComponent.cut();
    		}
    		public void paste(){
    			accessibleTextComponent.paste();
    		}
    		public void selectAll(){
    			accessibleTextComponent.selectAll();
    		}
             public class NumberPane extends JPanel implements DocumentListener,MouseListener,CaretListener{
             	private int width=20,lineCount=0,d_height=0;
                private Color foregroundColor;
                private Color defaultForegroundColor=new Color(128,0,0);
                private int selection=-1;
                public NumberPane(){
                   foregroundColor=defaultForegroundColor;
                   setPreferredSize(new Dimension(width,-1));
                   addMouseListener(this);
                   accessibleTextComponent.getDocument().addDocumentListener(this);
                   accessibleTextComponent.addCaretListener(this);
                }
                public void insertUpdate(DocumentEvent de){repaint();}
                public void removeUpdate(DocumentEvent de){repaint();}
                public void changedUpdate(DocumentEvent de){repaint();}
                public void mouseClicked(MouseEvent me){}
                public void mouseReleased(MouseEvent me){}
                public void mouseEntered(MouseEvent me){}
                public void mouseExited(MouseEvent me){}
                public void mousePressed(MouseEvent me){
                	if(SwingUtilities.isLeftMouseButton(me)){//only left click
                		selection=(me.getY())/d_height;
                		if(selection>=0&&selection<lineCount){
                			select(selection);
                			selection=-1;
                		}
                	}
                }
             	public void caretUpdate(CaretEvent ce){
              		try{
              			int l=accessibleTextComponent.getLineOfOffset(ce.getDot());
              			int c=accessibleTextComponent.getLineStartOffset(l);
               			l+=1;
               			c=ce.getDot()-c;
               			caretPosition.x=l;
               			caretPosition.y=c;
              		}catch(Exception e){}
             	}
             	public void select(int i){
              		try{
               			int s1=accessibleTextComponent.getLineStartOffset(i);
               			int s2=accessibleTextComponent.getLineEndOffset(i);
               			accessibleTextComponent.setCaretPosition(s1);
               			accessibleTextComponent.moveCaretPosition(s2);
              		}catch(Exception r){
                    	System.out.println(r);
                	}
             	}
             	public void paint(Graphics g){
             		super.paint(g);
                	Color old=g.getColor();
                	g.setColor(foregroundColor);
                	lineCount=accessibleTextComponent.getLineCount();
                	FontMetrics fm=accessibleTextComponent.getFontMetrics(accessibleTextComponent.getFont());
                	d_height=fm.getHeight();
                	int pwidth=fm.stringWidth(""+(lineCount+1))+4;
                	if(pwidth-width>=0){
                		width+=10;
                		setPreferredSize(new Dimension(width,-1));
                	}else{
                		if(pwidth-width<-10){
                			width-=10;
                			setPreferredSize(new Dimension(width,-1));
                		}
                	}
                	for(int i=0;i<lineCount+1;i++){
                		g.drawString((i+1)+"",2,i*d_height+d_height-4);
                	}
                	g.setColor(old);
             	}
             }
    }
    protected final class Filter extends FileFilter {
        protected final String ext;
        protected final String desc;
        protected Filter(String desc, String ext) {
            this.desc = desc != null ? desc : ext + " files";
            this.ext = ext;
        }
        protected Filter(String ext) {
            this(null, ext);
        }
        public String getDescription() {
            return desc;
        }
        public boolean accept(File file) {
            return file.getName().endsWith(ext);
        }
    }
}
