package parser;

/** Indicates that the parser built a syntax tree that violates some
 *  invariant. Should never be thrown; indicates a bug in the parser. (Bad
 *  input should be dealt with more gracefully than this.) */
class MalformedASTException extends RuntimeException {
    final GUINode node;
    
    MalformedASTException(GUINode node) {
        this.node = node;
    }

    public String getMessage() {
        return "Malformed AST:\n" + node.display();
    }
}