#!/usr/bin/perl

use strict;
use Data::Dumper;
use File::Find;
use File::Basename;

my @sourceFiles;

find sub { push @sourceFiles, $File::Find::name if /.*\.java$/ }, '.';

foreach my $file (@sourceFiles) {
    open IN, '<', $file;
    my @lines = ();
    while (<IN>) {
        s/^(public |final )*class /\@SuppressWarnings("all") $&/;
        push @lines, $_;
    }
    close IN;
    open OUT, '>', $file;
    print OUT join('', @lines);
    close OUT;
}

my $mkConstants = dirname($0);
$mkConstants = "$mkConstants/mkConstants.pl";
system $mkConstants;
